; rainbow-strips.scm
;
; This file create a gradient with seven strips in the colors of the rainbow.
;
; Written by Shlomi Fish, 1999.
;
; INSTRUCTIONS:
; Put this file in your ~/.gimp/scripts directory. Run the gimp and
; select the "Xtns -> Script-Fu -> Shlomif -> Rainbow Strips" menu item.
;
; The gradient-fu patch should be installed in order for this script to work.



(define (script-fu-shlomif1-rainbow-strips width)
    (let* (
    	(a 0)
        (pos 0)
        (colors '((1 0 0) (1 0.65 0) (0.96 1 0) (0 1 0) (0 1 0.75) (0 0 1) (1 0 1)))
        (edge-colors '((1 0.26 0.06) (1 0.8 0.04) (1 0.99 0.05) (0.03 1 0.32) (0.01 1 0.58) (0.38 0 1) (1 0 0.87)))
        (color '())
        (edge-color '())
    )

         (define (convert-color triplet)
                 (mapcar (lambda (p) (define (floor a) (- a (fmod a 1))) (floor (* 255 p))) triplet)
         )

         (gimp-gradients-new "shlomi-rainbow-strips")

         (gimp-gradients-set-active "shlomi-rainbow-strips")

         (gimp-gradients-set-selection 1 1000)
         (gimp-gradients-delete-selection)

         (set! a 1)
         (while (<= a 7)
         	(set! pos (- (* (/ 1 8) a) (/ width 2)))
                (gimp-gradients-set-middle-point-pos pos)
                (gimp-gradients-split-at-midpoint)

                (gimp-gradients-set-selection 1000 1000)

         	(set! pos (* (/ 1 8) a))
                (gimp-gradients-set-middle-point-pos pos)
                (gimp-gradients-split-at-midpoint)

                (gimp-gradients-set-selection 1000 1000)
                

                (set! pos (+ (* (/ 1 8) a) (/ width 2)))
                (gimp-gradients-set-middle-point-pos pos)
                (gimp-gradients-split-at-midpoint)

                (gimp-gradients-set-selection 1000 1000)

                (set! a (+ a 1))
         )

         (set! a 0)
         (while (< a 7)
         	(gimp-gradients-set-selection (* a 3) (* a 3))
                (gimp-gradients-set-left-end-color '(0 0 0) 0)
                (gimp-gradients-set-right-end-color '(0 0 0) 0)

                (set! color (convert-color (nth a colors)))
                (set! edge-color (convert-color (nth a edge-colors)))

                (gimp-gradients-set-selection (+ (* a 3) 1) (+ (* a 3) 1))
                (gimp-gradients-set-left-end-color edge-color 50)
                (gimp-gradients-set-right-end-color color 50)
                (gimp-gradients-set-blending-function GRAD_LINEAR)
                (gimp-gradients-set-coloring-type GRAD_RGB)
                

                (gimp-gradients-set-selection (+ (* a 3) 2) (+ (* a 3) 2))
                (gimp-gradients-set-left-end-color color 50)
                (gimp-gradients-set-right-end-color edge-color 50)
                (gimp-gradients-set-blending-function GRAD_LINEAR)
                (gimp-gradients-set-coloring-type GRAD_RGB)
                
                (set! a (+ a 1))
         )
         (gimp-gradients-set-selection (* 8 3) (* 8 3))
         (gimp-gradients-set-left-end-color '(0 0 0) 0)
         (gimp-gradients-set-right-end-color '(0 0 0) 0)

    )         
)


(script-fu-register "script-fu-shlomif1-rainbow-strips"
                    "<Toolbox>/Xtns/Script-Fu/Shlomif/Rainbow Strips"
                    "Generate a gradient with rainbow strips"
                    "Shlomi Fish <shlomif@vipe.technion.ac.il>"
                    "Shlomi Fish"
                    "September 1999"
                    ""
                    SF-VALUE "Width" "0.05"
                    )
                    
